unit ProgressFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls;

type
  TProgressForm = class(TForm)
    ProgressBar1: TProgressBar;
    SpeedButton1: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
  private
    FCheck:PBoolean;
  public
    procedure InitProgress(Text:string;var Check:Boolean);
    procedure UpdateProgress(Value:Byte);
    procedure CloseProgress;
  end;

var
  ProgressForm: TProgressForm;

implementation

uses
  MainFormUnit;

{$R *.dfm}

procedure TProgressForm.CloseProgress;
begin
  Close;
  MainForm.Enabled:=True;
  MainForm.Show;
end;

procedure TProgressForm.InitProgress(Text: string; var Check: Boolean);
begin
  MainForm.Enabled:=False;
  Show;
  Caption:=Text;
  FCheck:=@Check;
  Check:=False;
  ProgressBar1.Position:=0;
  Application.ProcessMessages;
end;

procedure TProgressForm.UpdateProgress(Value: Byte);
begin
  ProgressBar1.Position:=Value;
  Application.ProcessMessages;
end;

procedure TProgressForm.SpeedButton1Click(Sender: TObject);
begin
  FCheck^:=True;
end;

end.
