object MainForm: TMainForm
  Left = 357
  Top = 179
  Width = 870
  Height = 723
  Caption = 'Graphic to ASCII converter'
  Color = clBtnFace
  Font.Charset = DEFAULT_CHARSET
  Font.Color = clWindowText
  Font.Height = -11
  Font.Name = 'MS Sans Serif'
  Font.Style = []
  OldCreateOrder = False
  Position = poDesktopCenter
  OnCreate = FormCreate
  OnDestroy = FormDestroy
  PixelsPerInch = 96
  TextHeight = 13
  object PageControl: TPageControl
    Left = 0
    Top = 0
    Width = 862
    Height = 624
    ActivePage = ASCIIConversionTabSheet
    Align = alClient
    Constraints.MinHeight = 560
    Constraints.MinWidth = 600
    TabOrder = 0
    OnChange = PageControlChange
    object OriginalImageTabSheet: TTabSheet
      Caption = 'Original image'
      object OriginalImageScrollBox: TScrollBox
        Left = 0
        Top = 0
        Width = 854
        Height = 596
        HorzScrollBar.Smooth = True
        HorzScrollBar.Tracking = True
        VertScrollBar.Smooth = True
        VertScrollBar.Tracking = True
        Align = alClient
        TabOrder = 0
        object OriginalImagePaintBox: TPaintBox
          Left = 0
          Top = 0
          Width = 36
          Height = 31
          OnPaint = OriginalImagePaintBoxPaint
        end
      end
    end
    object FilteredImageTabSheet: TTabSheet
      Caption = 'Filtered image'
      ImageIndex = 2
      object FilteredImageScrollBox: TScrollBox
        Left = 0
        Top = 0
        Width = 529
        Height = 596
        HorzScrollBar.Smooth = True
        HorzScrollBar.Tracking = True
        VertScrollBar.Smooth = True
        VertScrollBar.Tracking = True
        Align = alClient
        TabOrder = 0
        object FilteredImagePaintBox: TPaintBox
          Left = 0
          Top = 0
          Width = 36
          Height = 31
          OnPaint = FilteredImagePaintBoxPaint
        end
      end
      object SidePanel1: TPanel
        Left = 529
        Top = 0
        Width = 325
        Height = 596
        Align = alRight
        BevelOuter = bvNone
        TabOrder = 1
        DesignSize = (
          325
          596)
        object MedianFilterSizeRadioGroup: TRadioGroup
          Left = 10
          Top = 10
          Width = 309
          Height = 96
          Anchors = [akLeft, akTop, akRight]
          Caption = 'Median box filter'
          Columns = 2
          ItemIndex = 1
          Items.Strings = (
            '1 x 1 (no filter)'
            '3 x 3'
            '5 x 5'
            '7 x 7'
            '9 x 9'
            '11 x 11')
          TabOrder = 0
        end
        object GroupBox2: TGroupBox
          Left = 10
          Top = 110
          Width = 309
          Height = 196
          Anchors = [akLeft, akTop, akRight]
          Caption = 'Resizing'
          TabOrder = 1
          DesignSize = (
            309
            196)
          object RatioSpeedButton1: TSpeedButton
            Tag = 16
            Left = 125
            Top = 110
            Width = 30
            Height = 26
            Anchors = [akTop, akRight]
            Caption = '4:1'
            OnClick = RatioSpeedButton1Click
          end
          object RatioSpeedButton2: TSpeedButton
            Tag = 8
            Left = 160
            Top = 110
            Width = 30
            Height = 26
            Anchors = [akTop, akRight]
            Caption = '2:1'
            OnClick = RatioSpeedButton1Click
          end
          object RatioSpeedButton3: TSpeedButton
            Tag = 4
            Left = 195
            Top = 110
            Width = 30
            Height = 26
            Anchors = [akTop, akRight]
            Caption = '1:1'
            OnClick = RatioSpeedButton1Click
          end
          object RatioSpeedButton4: TSpeedButton
            Tag = 2
            Left = 230
            Top = 110
            Width = 30
            Height = 26
            Anchors = [akTop, akRight]
            Caption = '1:2'
            OnClick = RatioSpeedButton1Click
          end
          object RatioSpeedButton5: TSpeedButton
            Tag = 1
            Left = 265
            Top = 110
            Width = 30
            Height = 26
            Anchors = [akTop, akRight]
            Caption = '1:4'
            OnClick = RatioSpeedButton1Click
          end
          object KeepRatioCheckBox: TCheckBox
            Left = 6
            Top = 115
            Width = 75
            Height = 17
            Anchors = [akLeft, akTop, akRight]
            Caption = 'Keep ratio'
            Checked = True
            State = cbChecked
            TabOrder = 0
          end
          object XFactorTrackBar: TTrackBar
            Left = 65
            Top = 50
            Width = 235
            Height = 21
            Anchors = [akLeft, akTop, akRight]
            Max = 1500
            Min = 10
            Position = 100
            TabOrder = 1
            ThumbLength = 15
            TickMarks = tmBoth
            TickStyle = tsNone
            OnChange = XFactorTrackBarChange
          end
          object YFactorTrackBar: TTrackBar
            Left = 65
            Top = 85
            Width = 235
            Height = 21
            Anchors = [akLeft, akTop, akRight]
            Max = 1500
            Min = 10
            Position = 100
            TabOrder = 2
            ThumbLength = 15
            TickMarks = tmBoth
            TickStyle = tsNone
            OnChange = XFactorTrackBarChange
          end
          object StaticPanel1: TPanel
            Left = 5
            Top = 50
            Width = 56
            Height = 21
            Alignment = taRightJustify
            BevelOuter = bvLowered
            Caption = 'X factor: '
            TabOrder = 3
          end
          object StaticPanel2: TPanel
            Left = 5
            Top = 85
            Width = 56
            Height = 21
            Alignment = taRightJustify
            BevelOuter = bvLowered
            Caption = 'Y factor: '
            TabOrder = 4
          end
          object ResizePanel: TPanel
            Left = 11
            Top = 20
            Width = 284
            Height = 21
            Anchors = [akLeft, akTop, akRight]
            BevelOuter = bvLowered
            Caption = '0 x 0 -> 0 x 0'
            TabOrder = 5
          end
          object ResizingMethodRadioGroup: TRadioGroup
            Left = 10
            Top = 145
            Width = 286
            Height = 41
            Caption = 'Resizing method'
            Columns = 2
            ItemIndex = 1
            Items.Strings = (
              'Nearest neightbor'
              'Bilinear')
            TabOrder = 6
          end
        end
      end
    end
    object ASCIIConversionTabSheet: TTabSheet
      Caption = 'ASCII conversion'
      ImageIndex = 1
      object ASCIIMemo: TMemo
        Left = 0
        Top = 0
        Width = 529
        Height = 596
        Align = alClient
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -11
        Font.Name = 'Webdings'
        Font.Style = []
        ParentFont = False
        ReadOnly = True
        ScrollBars = ssBoth
        TabOrder = 0
        WordWrap = False
      end
      object SidePanel2: TPanel
        Left = 529
        Top = 0
        Width = 325
        Height = 596
        Align = alRight
        BevelOuter = bvNone
        TabOrder = 1
        DesignSize = (
          325
          596)
        object CopyToClipboardSpeedButton: TSpeedButton
          Left = 5
          Top = 500
          Width = 151
          Height = 31
          Caption = 'Copy to clipboard'
          OnClick = CopyToClipboardSpeedButtonClick
        end
        object CopyHTMLToClipboardSpeedButton: TSpeedButton
          Left = 169
          Top = 500
          Width = 151
          Height = 31
          Anchors = [akTop, akRight]
          Caption = 'Copy to clipboard (HTML)'
          OnClick = CopyHTMLToClipboardSpeedButtonClick
        end
        object FontPanel: TPanel
          Left = 5
          Top = 5
          Width = 314
          Height = 26
          Alignment = taLeftJustify
          Anchors = [akLeft, akTop, akRight]
          BevelOuter = bvLowered
          Caption = '  Font:'
          TabOrder = 0
          object ChangeFontSpeedButton: TSpeedButton
            Left = 265
            Top = 0
            Width = 31
            Height = 22
            Caption = '...'
            OnClick = ChangeFontSpeedButtonClick
          end
        end
        object UseGammaCorrectionCheckBox: TCheckBox
          Left = 5
          Top = 40
          Width = 314
          Height = 17
          Anchors = [akLeft, akTop, akRight]
          Caption = 'Use gamma correction'
          Checked = True
          State = cbChecked
          TabOrder = 1
        end
        object GroupBox1: TGroupBox
          Left = 5
          Top = 175
          Width = 316
          Height = 316
          Anchors = [akLeft, akTop, akRight]
          Caption = 'Weight matrix'
          TabOrder = 2
          DesignSize = (
            316
            316)
          object LoadMatrixSpeedButton: TSpeedButton
            Left = 228
            Top = 250
            Width = 81
            Height = 26
            Anchors = [akRight, akBottom]
            Caption = 'Load'
            Enabled = False
            OnDblClick = MatrixListBoxDblClick
          end
          object SaveNewMatrixSpeedButton: TSpeedButton
            Left = 228
            Top = 280
            Width = 81
            Height = 26
            Anchors = [akRight, akBottom]
            Caption = 'Save as new'
            Enabled = False
            OnClick = SaveNewMatrixSpeedButtonClick
          end
          object DeleteMatrixSpeedButton: TSpeedButton
            Left = 228
            Top = 220
            Width = 81
            Height = 26
            Anchors = [akRight, akBottom]
            Caption = 'Delete'
            Enabled = False
            OnClick = DeleteMatrixSpeedButtonClick
          end
          object MatrixPanel1: TPanel
            Left = 10
            Top = 45
            Width = 141
            Height = 21
            Hint = 'LL filter weight'
            Caption = 'MatrixPanel1'
            TabOrder = 0
          end
          object MatrixTrackBar1: TTrackBar
            Left = 10
            Top = 70
            Width = 141
            Height = 21
            Hint = 'Intensity '
            Max = 1000
            Min = 1
            Position = 900
            TabOrder = 1
            ThumbLength = 15
            TickMarks = tmBoth
            TickStyle = tsNone
            OnChange = MatrixTrackBar1Change
          end
          object MatrixPanel2: TPanel
            Left = 162
            Top = 45
            Width = 141
            Height = 21
            Anchors = [akTop, akRight]
            Caption = 'MatrixPanel2'
            TabOrder = 2
          end
          object MatrixTrackBar2: TTrackBar
            Left = 162
            Top = 70
            Width = 141
            Height = 21
            Hint = 'Horizontal slope'
            Anchors = [akTop, akRight]
            Max = 1000
            Position = 250
            TabOrder = 3
            ThumbLength = 15
            TickMarks = tmBoth
            TickStyle = tsNone
            OnChange = MatrixTrackBar1Change
          end
          object MatrixPanel3: TPanel
            Left = 10
            Top = 101
            Width = 141
            Height = 21
            Caption = 'MatrixPanel3'
            TabOrder = 4
          end
          object MatrixTrackBar3: TTrackBar
            Left = 10
            Top = 126
            Width = 141
            Height = 21
            Hint = 'Vertical slope'
            Max = 1000
            Position = 250
            TabOrder = 5
            ThumbLength = 15
            TickMarks = tmBoth
            TickStyle = tsNone
            OnChange = MatrixTrackBar1Change
          end
          object MatrixPanel4: TPanel
            Left = 162
            Top = 101
            Width = 141
            Height = 21
            Anchors = [akTop, akRight]
            Caption = 'MatrixPanel4'
            TabOrder = 6
          end
          object MatrixTrackBar4: TTrackBar
            Left = 162
            Top = 126
            Width = 141
            Height = 21
            Hint = 'Diagonal slope'
            Anchors = [akTop, akRight]
            Max = 1000
            Position = 125
            TabOrder = 7
            ThumbLength = 15
            TickMarks = tmBoth
            TickStyle = tsNone
            OnChange = MatrixTrackBar1Change
          end
          object MatrixListBox: TListBox
            Left = 10
            Top = 175
            Width = 210
            Height = 106
            Anchors = [akLeft, akTop, akRight, akBottom]
            ItemHeight = 13
            TabOrder = 8
            OnClick = MatrixListBoxClick
            OnDblClick = MatrixListBoxDblClick
          end
          object MatrixNameEdit: TEdit
            Left = 10
            Top = 285
            Width = 210
            Height = 21
            Anchors = [akLeft, akRight, akBottom]
            TabOrder = 9
            OnChange = MatrixNameEditChange
          end
          object SymmetricCheckBox: TCheckBox
            Left = 10
            Top = 152
            Width = 96
            Height = 17
            Anchors = [akLeft, akTop, akRight]
            Caption = 'Symmetric filter'
            Checked = True
            State = cbChecked
            TabOrder = 10
          end
          object AutoAdjustCheckBox: TCheckBox
            Left = 10
            Top = 17
            Width = 291
            Height = 17
            Anchors = [akLeft, akTop, akRight]
            Caption = 'Auto-adjust'
            Checked = True
            State = cbChecked
            TabOrder = 11
            OnClick = AutoAdjustCheckBoxClick
          end
        end
        object OnlyAlphanumericCheckBox: TCheckBox
          Left = 5
          Top = 60
          Width = 314
          Height = 17
          Anchors = [akLeft, akTop, akRight]
          Caption = 'Use only alphanumeric characters'
          TabOrder = 3
        end
        object WhiteOnBlackCheckBox: TCheckBox
          Left = 5
          Top = 80
          Width = 314
          Height = 17
          Anchors = [akLeft, akTop, akRight]
          Caption = 'White on black'
          TabOrder = 4
        end
        object WaveletQualityRadioGroup: TRadioGroup
          Left = 5
          Top = 120
          Width = 314
          Height = 51
          Caption = 'Wavelet quality'
          Columns = 3
          ItemIndex = 2
          Items.Strings = (
            'Bad'
            'Mean'
            'High'
            'Very high'
            'Best')
          TabOrder = 5
          OnClick = WaveletQualityRadioGroupClick
        end
        object RidgeletModeCheckBox: TCheckBox
          Left = 5
          Top = 100
          Width = 314
          Height = 17
          Anchors = [akLeft, akTop, akRight]
          Caption = 'Use ridgelet transform'
          TabOrder = 6
          Visible = False
        end
      end
    end
  end
  object BottomPanel: TPanel
    Left = 0
    Top = 624
    Width = 862
    Height = 66
    Align = alBottom
    BevelOuter = bvNone
    TabOrder = 1
    DesignSize = (
      862
      66)
    object BackBitBtn: TBitBtn
      Left = 10
      Top = 5
      Width = 106
      Height = 56
      Caption = 'Previous'
      TabOrder = 0
      OnClick = BackBitBtnClick
      Glyph.Data = {
        A60C0000424DA60C00000000000036040000280000002D0000002D0000000100
        080000000000700800000CB305000CB3050000010000000000000B0909000F0E
        0E0043414100717070005B5A5A00F9F8F800AFAEAE00625D5C002C2523000906
        05005A5452004A474600383331003C373500423D3B001C181600201E1D002523
        2200302E2D003D3B3A0015100D002C221C00261E19001A151200413024004432
        260042312500332922000E0A07006C503B005C44320076584100523D2E003D2E
        23005E48370048372A0067544600504C4900F3964A00F0944900DC884300C278
        3B00BF763A00BC743900AB6A3400A86833009B602F00955C2D00945B2D008E58
        2B008B562A008A552A008854290087542900F6984B00F5984B00F4974B00F295
        4A00F0954A00EF944900EE934900EB924800EA914800E88F4700E8904700E58E
        4600E48D4600E38D4600E28B4500E28C4500E18B4500DF8A4400DE894400DD89
        4400DB884300DA874300D8864200D6854200D4834100D2824000D0814000CE80
        3F00CA7D3E00C77B3D00C67A3D00C4793C00C0773B00BE753A00BD753A00BB74
        3900BA733900B9733900B46F3700B06D3600AD6B3500AA693400A9683400A767
        3300A4653200A4663200A06331009D613000995F2F00965D2E00935B2D008D57
        2B0089552A00865329008552290082502800804F2700EC924900E9914800E68F
        4700C0C0C000C2783C00A26432009A603000955C2E00915A2D00E7904900D786
        4400D1824200C67B3E00DF8C4700D9884500B6723A00E5904A00CD804200CA7F
        41009E643300E08D4900CE8243009F643400DB8B4800D1854500CF8344007C4E
        2900E6924D00A4683700D4874800C9804400E7934F00E1904D0099623500AE6F
        3D0083542E00D4884B009F673900925E3400DF915100BE7C4500EB995600E293
        5300F19F5C00C3804A007C522F00F2A26000D18C5300754F2F009D694000FBAB
        6A00895D3A0096684300E7A56F008A63440074543B00C9966D00664D38004534
        26008F6D52004C3B2D00524031005F4B3A00F8C49900E7B68E0051423600CCA7
        8A008C7460009A816D003E342C0053473D00FDB5770046382B00AC8B6E004236
        2B00161310000F0D0B00100F0E00FFC58300FCD5A500FFD29900FFD18F00FFD8
        960006050300FFE4A400161615001919180094949300FFFFFF00FCFCFC00F3F3
        F300E5E5E500CECECE00545454004F4F4F0037373700333333002A2A2A001B1B
        1B00111111000B0B0B0009090900060606000202020000000000000000000000
        0000000000000000000000000000000000000000000000000000000000000000
        0000000000000000000000000000000000000000000000000000000000000000
        0000000000000000000000000000000000000000000000000000000000000000
        0000000000000000000000000000000000000000000000000000000000000000
        0000000000000000000000000000000000000000000000000000727272727272
        7272727272727272727272727272727272727272727272727272727272727272
        72727272727272000000727272727272727272727272727272720604130C0C0D
        0E02020E0E0C0D03CB7272727272727272727272727272000000727272727272
        7272727272727272060423231E735280847A7A8C96980B0D0CCDC67272727272
        72727272727272000000727272727272727272727272CB03CE1F1D2B58567B80
        7A4D797D86999DA4AAADB5037272727272727272727272000000727272727272
        727272727206CE221F7E5A544F2842703C2637383A7186969DA1B6B225CB7272
        727272727272720000007272727272727272727206D0A6A35C524B423D393738
        3B7146413A386F718696A1BDB1B0C67272727272727272000000727272727272
        72727206121DA05A4D3F3B3836363945535D5F91544639393C78439DC0BE0AC6
        72727272727272000000727272727272727206B01D2C56493C383636373B482B
        6182ABD76658413837263C7898BDBEB306727272727272000000727272727272
        72CB12A82D55463B373636373B495A608BABD7D7357449263636373A3F8EB6BE
        B8CB72727272720000007272727272727202A6642B4627373636373B285A60A0
        1BD7D7D734674C2636363637263D8AB6B1077272727272000000727272727272
        C6CF90624D3C373636373C285A60A315D7D7D7D734684C263636363636386F8A
        B6B3C6727272720000007272727272CB201F65563F383636383D4A5B60A514D7
        D701D7D7342F4D3C262626262638263D83A72406727272000000727272727207
        1A2E634D3A3636393F4E5C611FC2D7D7C5C6D7D76B2F544D4C4C4C4C4C4A4641
        46501F12CB7272000000727272720608A265563F37362746536363A8D7D7D7D1
        0672D7D76A332F2F686868686876652C592A97D0077272000000727272722521
        75634B263627482A6285ACD7D7D712067272D7D75F6A6B346A6A6A6A6A6A3369
        302D541112727200000072727272081E75563E363949596194B9D7D7D713CB72
        7272D7D7D7D7D7D7D7D7D7D7D7D7D7D7D7D7D7D70F7272000000727272C60895
        674E2626475960A015D7D7D6CDCB72727272D7D7D1D7D7D6D6D6D6D6D6D6D6D6
        D6D6D6D6D67272000000727272071832654438452B60A317D7D7D60772727272
        72727272727272727272727272727272727272727272720000007272720A1932
        5F3E402960A51CD7D7D303727272727272727272727272727272727272727272
        727272727272720000007272720718322B3B4D2CA6C2D7D7D2C6727272727272
        7272727272727272727272727272727272727272727272000000727272041869
        51398D22D7D7D710067272727272727272727272727272727272727272727272
        72727272727272000000727272071A3128261FD7D7D7CF067272727272727272
        727272727272727272727272727272727272727272727200000072727207A931
        28389EB0D7CECB72727272727272727272727272727272727272727272727272
        727272727272720000007272720AA9314F388AA4BAC4CE727272727272727272
        727272727272727272727272727272727272727272727200000072727203A932
        572670B6BF15D2D1727272727272727272727272727272727272727272727272
        7272727272727200000072727206196B6440398EC0C3B4BAD2CB727272727272
        727272727272727272727272727272727272727272727200000072727272A99C
        6B52383C98C0C324BBD306727272727272727272727272727272727272727272
        72727272727272000000727272720D186D6545373E98BDC1B8BCD2C672727272
        7272D7D1D1D1D1D1D1D1D1D1D1D1D1D1D1D1D1C500727200000072727272C618
        A66C5527383E8AA1C1AFBCD2037272727272D4D7D7D7D7D7D6D6D6D6D6D6D6D6
        D6D7D7D7D7727200000072727272720B219C624637383D789DC1BE0FD2CC7272
        7272D4D7567E738180848484848887938F8A96111B72720000007272727272C6
        081E6B513B36383B789DC1C31201CF727272D4D7645E2A7B818181818087867F
        7F7CAA080872720000007272727272CBCF1E6D5D433836373A789AC0C3B500D1
        7272D4D768614F464343424271703D424F971515D27272000000727272727272
        C61A9F6B523D3736373A4098BDC1B2BB01CBD4D7692E4B3B2626263838394353
        7EB9D7D7CD727200000072727272727272CD238966503D38363639708AA1C0B1
        BAD4D4D731664B26363636373A472A5D22D7D7D1067272000000727272727272
        72CB122389665241393636266F7F9DC1AE17D7D7672D49263636373B49592CA5
        D7D7D70372727200000072727272727272720611236E355B493B3636383B789A
        BDB6D3D75E29413836383D4B5B60A3BCD7D7CECB727272000000727272727272
        727272C61BAC896D5F4D3C37363639709998939B50463A263B414F5C2D1FC2D7
        D7D1067272727200000072727272727272727272C6C421896E644F4039383738
        3A3D71403B383B454F58747422D7D7D7C5C67272727272000000727272727272
        7272727272C6101B9F6E66734E4C49433D3937382745525D666690ACD7D7D711
        06727272727272000000727272727272727272727272C61115AB9C6B3168672E
        615D7E5B5D64676795A616D7D7D7D00672727272727272000000727272727272
        72727272727272CB02C220A692346A6A3333323231771D1B14D7D7D7C404CB72
        72727272727272000000727272727272727272727272727272C6CD0909091416
        B9B7211714D4D7D7D7D7C2C67272727272727272727272000000727272727272
        7272727272727272727272CB02D7D7D7D7D7D7D7D7D2CC0606CB727272727272
        7272727272727200000072727272727272727272727272727272727272727272
        7272727272727272727272727272727272727272727272000000007272727272
        7272727272727272727272727272727272727272727272727272727272727272
        72727272727272000000}
    end
    object NextBitBtn: TBitBtn
      Left = 745
      Top = 5
      Width = 106
      Height = 56
      Anchors = [akTop, akRight]
      Caption = 'Next'
      TabOrder = 1
      OnClick = NextBitBtnClick
      Glyph.Data = {
        A60C0000424DA60C00000000000036040000280000002D0000002D0000000100
        080000000000700800000DB305000DB3050000010000000000000B0909000F0E
        0E0043414100717070005B5A5A00F9F8F800AFAEAE00625D5C002C2523000906
        05005A5452004A474600383331003C373500423D3B001C181600201E1D002523
        2200302E2D003D3B3A0015100D002C221C00261E19001A151200413024004432
        260042312500332922000E0A07006C503B005C44320076584100523D2E003D2E
        23005E48370048372A0067544600504C4900F3964A00F0944900DC884300C278
        3B00BF763A00BC743900AB6A3400A86833009B602F00955C2D00945B2D008E58
        2B008B562A008A552A008854290087542900F6984B00F5984B00F4974B00F295
        4A00F0954A00EF944900EE934900EB924800EA914800E88F4700E8904700E58E
        4600E48D4600E38D4600E28B4500E28C4500E18B4500DF8A4400DE894400DD89
        4400DB884300DA874300D8864200D6854200D4834100D2824000D0814000CE80
        3F00CA7D3E00C77B3D00C67A3D00C4793C00C0773B00BE753A00BD753A00BB74
        3900BA733900B9733900B46F3700B06D3600AD6B3500AA693400A9683400A767
        3300A4653200A4663200A06331009D613000995F2F00965D2E00935B2D008D57
        2B0089552A00865329008552290082502800804F2700EC924900E9914800E68F
        4700C0C0C000C2783C00A26432009A603000955C2E00915A2D00E7904900D786
        4400D1824200C67B3E00DF8C4700D9884500B6723A00E5904A00CD804200CA7F
        41009E643300E08D4900CE8243009F643400DB8B4800D1854500CF8344007C4E
        2900E6924D00A4683700D4874800C9804400E7934F00E1904D0099623500AE6F
        3D0083542E00D4884B009F673900925E3400DF915100BE7C4500EB995600E293
        5300F19F5C00C3804A007C522F00F2A26000D18C5300754F2F009D694000FBAB
        6A00895D3A0096684300E7A56F008A63440074543B00C9966D00664D38004534
        26008F6D52004C3B2D00524031005F4B3A00F8C49900E7B68E0051423600CCA7
        8A008C7460009A816D003E342C0053473D00FDB5770046382B00AC8B6E004236
        2B00161310000F0D0B00100F0E00FFC58300FCD5A500FFD29900FFD18F00FFD8
        960006050300FFE4A400161615001919180094949300FFFFFF00FCFCFC00F3F3
        F300E5E5E500CECECE00545454004F4F4F0037373700333333002A2A2A001B1B
        1B00111111000B0B0B0009090900060606000202020000000000000000000000
        0000000000000000000000000000000000000000000000000000000000000000
        0000000000000000000000000000000000000000000000000000000000000000
        0000000000000000000000000000000000000000000000000000000000000000
        0000000000000000000000000000000000000000000000000000000000000000
        0000000000000000000000000000000000000000000000000000727272727272
        7272727272727272727272727272727272727272727272727272727272727272
        7272727272727204000072727272727272727272727272727272727272727272
        7272727272727272727272727272727272727272727272040000727272727272
        7272727272727272CB0606CCD2D7D7D7D7D7D7D7D702CB727272727272727272
        72727272727272040000727272727272727272727272C6C2D7D7D7D7D4141721
        B7B91614090909CDC67272727272727272727272727272040000727272727272
        727272CB04C4D7D7D7141B1D7731323233336A6A3492A620C202CB7272727272
        72727272727272040000727272727272727206D0D7D7D716A6956767645D5B7E
        5D612E6768316B9CAB1511C67272727272727272727272040000727272727272
        720611D7D7D7AC9066665D5245273837393D43494C4E73666E9F1B10C6727272
        72727272727272040000727272727272C6C5D7D7D7227474584F453B383B4071
        3D3A38373839404F646E8921C4C6727272727272727272040000727272727206
        D1D7D7C21F2D5C4F413B263A46509B93989970393636373C4D5F6D89AC1BC672
        7272727272727204000072727272CBCED7D7BCA3605B4B3D38363841295ED7D3
        B6BD9A783B3836363B495B356E231106727272727272720400007272727203D7
        D7D7A52C59493B37363626492D67D7D717AEC19D7F6F26363639415266892312
        CB72727272727204000072727206D1D7D7225D2A473A37363636264B6631D7D4
        D4BAB1C0A18A70393636383D50668923CD727272727272040000727272CDD7D7
        B97E53433938382626263B4B2E69D7D4CB01BBB2C1BD98403A3736373D526B9F
        1AC67272727272040000727272D21515974F423D707142424343464F6168D7D4
        7272D100B5C3C09A783A373638435D6D1ECFCB727272720400007272720808AA
        7C7F7F868780818181817B2A5E64D7D4727272CF0112C3C19D783B38363B516B
        1E08C6727272720400007272721B11968A8F938788848484848081737E56D7D4
        72727272CCD20FBEC19D783D383746629C210B72727272040000727272D7D7D7
        D7D6D6D6D6D6D6D6D6D6D7D7D7D7D7D4727272727203D2BCAFC1A18A3E382755
        6CA618C672727204000072727200C5D1D1D1D1D1D1D1D1D1D1D1D1D1D1D1D1D7
        727272727272C6D2BCB8C1BD983E3745656D180D727272040000727272727272
        727272727272727272727272727272727272727272727206D3BB24C3C0983C38
        526B9CA972727204000072727272727272727272727272727272727272727272
        7272727272727272CBD2BAB4C3C08E3940646B19067272040000727272727272
        7272727272727272727272727272727272727272727272727272D1D215BFB670
        265732A903727204000072727272727272727272727272727272727272727272
        7272727272727272727272CEC4BAA48A384F31A90A7272040000727272727272
        727272727272727272727272727272727272727272727272727272CBCED7B09E
        382831A907727204000072727272727272727272727272727272727272727272
        7272727272727272727206CFD7D7D71F2628311A077272040000727272727272
        727272727272727272727272727272727272727272727272720610D7D7D7228D
        3951691804727204000072727272727272727272727272727272727272727272
        7272727272727272C6D2D7D7C2A62C4D3B2B3218077272040000727272727272
        727272727272727272727272727272727272727272727203D3D7D71CA5602940
        3E5F32190A727204000072727272727272727272727272727272727272727272
        72727272727207D6D7D717A3602B453844653218077272040000727272D6D6D6
        D6D6D6D6D6D6D6D6D6D6D6D7D7D1D7D772727272CBCDD6D7D715A06059472626
        4E679508C672720400007272720FD7D7D7D7D7D7D7D7D7D7D7D7D7D7D7D7D7D7
        727272CB13D7D7D7B99461594939363E56751E08727272040000727272121154
        2D3069336A6A6A6A6A6A346B6A5FD7D772720612D7D7D7AC85622A482736264B
        6375212572727204000072727207D0972A592C657668686868682F2F336AD7D7
        7206D1D7D7D7A8636353462736373F5665A20806727272040000727272CB121F
        504641464A4C4C4C4C4C4D542F6BD7D7C6C5D7D7C21F615C4E3F3936363A4D63
        2E1A0772727272040000727272720624A7833D263826262626263C4D2F34D7D7
        01D7D714A5605B4A3D383636383F56651F20CB727272720400007272727272C6
        B3B68A6F383636363636264C6834D7D7D7D715A3605A283C373636373C4D6290
        CFC6727272727204000072727272727207B1B68A3D2637363636264C6734D7D7
        D71BA0605A283B3736363727462B64A602727272727272040000727272727272
        CBB8BEB68E3F3A37363626497435D7D7AB8B605A493B373636373B46552DA812
        CB7272727272720400007272727272727206B3BEBD98783C263738415866D7AB
        82612B483B373636383C49562C1DB00672727272727272040000727272727272
        7272C60ABEC09D43783C39394654915F5D5345393636383B3F4D5AA01D120672
        72727272727272040000727272727272727272C6B0B1BDA19686716F383A4146
        713B3837393D424B525CA3A6D006727272727272727272040000727272727272
        72727272CB25B2B6A19D9686713A3837263C7042284F545A7E1F22CE06727272
        7272727272727204000072727272727272727272727203B5ADAAA49D99867D79
        4D7A807B56582B1D1FCE03CB7272727272727272727272040000727272727272
        72727272727272C6CD0C0D0B98968C7A7A848052731E23230406727272727272
        72727272727272040000727272727272727272727272727272CB030D0C0E0E02
        020E0D0C0C130406727272727272727272727272727272040000727272727272
        7272727272727272727272727272727272727272727272727272727272727272
        72727272727272040000}
      Layout = blGlyphRight
    end
    object ProcessBitBtn: TBitBtn
      Left = 550
      Top = 5
      Width = 168
      Height = 56
      Anchors = [akTop, akRight]
      Caption = 'Process current step'
      Default = True
      ModalResult = 1
      TabOrder = 2
      WordWrap = True
      OnClick = ProcessBitBtnClick
      Glyph.Data = {
        1E180000424D1E1800000000000036000000280000002D0000002D0000000100
        180000000000E817000000000000000000000000000000000000C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C07170707170700000
        00000000000000000000000000717070717070C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C07170705B5A5A
        3D3B3A383331383331434141423D3B3C37353833313833313D3B3A5B5A5A7170
        70C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0AFAEAE5B
        5A5A48372A48372A5C4432C2783CCA7D3ED18242CE8243CD8042CA7D3EC2783C
        5C443248372A48372A5B5A5AAFAEAEC0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0CECE
        CE7170703737377658416C503BBC7439BD753AC0773BC67B3ED68542D18242CD
        8042C67B3EC0773BBD753ABC74396C503B765841373737717070CECECEC0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0AFAEAE3737375E4837765841B6723ABA7339C67A3DD28240DC8843E48D
        46F3964AEE9349E99148E48D46DC8843D28240C67A3DBA7339B6723A7658415E
        4837373737AFAEAEC0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0AFAEAE2A2A2A74543B966843B46F37CA7D3EDA8743E48D46
        EB9248F2954AF5984BF5984BF5984BF5984BF5984BF2954AEB9248E48D46DA87
        43CA7D3EB46F3796684374543B2A2A2AAFAEAEC0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0AFAEAE302E2D6C503B9D6940BA7339D68542E8
        8F47EF9449F4974BF6984BF6984BF5984BF5984BF5984BF5984BF5984BF6984B
        F6984BF4974BEF9449E88F47D68542BA73399D69406C503B302E2DAFAEAEC0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0AFAEAE5142366C503BAB6A34C077
        3BDD8944EE9349F4974BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5
        984BF5984BF5984BF5984BF5984BF6984BF4974BEE9349DD8944C0773BAB6A34
        6C503B514236AFAEAEC0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0CECECE302E2D664D38
        A86833C4793CE18B45EF9449F5984BF6984BF5984BF5984BF5984BF5984BF598
        4BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF6984BF6984BF5984BEF
        9449E18B45C4793CA86833664D38302E2DCECECEC0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C043
        414174543BA06331BC7439E18B45F09449F5984BF6984BF6984BF5984BF5984B
        A46632A46632F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF598
        4BF5984BF6984BF5984BF09449E18B45BC7439A0633174543B434141C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0949493333333996235A46532D68542EE9349F5984BF6984BF6984BF5
        984BF5984BA46632000000000000A46632F5984BF5984BF5984BF5984BF5984B
        F5984BF5984BF5984BF5984BF6984BF6984BF5984BEE9349D68542A465329962
        35333333949493C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0CECECE523D2E7658419D6130C0773BE88F47F2954AF295
        4AF2954AF2954AF2954AA46632000000808080C0C0C0000000A46632F5984BF5
        984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B
        E88F47C0773B9D6130765841523D2ECECECEC0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0625D5C4231259B602FA46632D68542
        F5984BF5984BF5984BF5984BF5984BA46632000000808080C0C0C0000000C0C0
        C0000000A46632F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5
        984BF5984BF5984BF0954AD68542A466329B602F423125625D5CC0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0AFAEAE2C2523895D3A9D
        6130C0773BE88F47F5984BF5984BF5984BF5984BA46632000000808080C0C0C0
        000000000000C0C0C0808080000000A46632F5984BF5984BF5984BF5984BF598
        4BF5984BF5984BF5984BF5984BF5984BF5984BE88F47C0773B9D6130895D3A2C
        2523AFAEAEC0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0504C
        493D2E239A6030A46632DA8743F3964AF5984BF5984BF5984BA4663200000080
        8080C0C0C0000000BA7339A46632000000C0C0C0808080000000A46632F5984B
        F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF6984BF3964ADA87
        43A466329A60303D2E23504C49C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C0C0C0C02C25235C44329A6030C0773BEA9148F6984BF5984BF5984BA466
        32000000808080C0C0C0000000BA7339F5984BF5984B000000808080C0C0C080
        8080000000A46632F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B
        F5984BF6984BEA9148C0773B9A60305C44322C2523C0C0C0C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C09494932C2523925E34965D2ED48341F3964AF2954A
        F5984BA46632000000808080C0C0C0000000BA7339F5984BF5984BF5984BA466
        32000000808080C0C0C0000000A46632F5984BF5984BF5984BF5984BF5984BF5
        984BF5984BF5984BF5984BF3964AF3964AD48341965D2E925E342C2523949493
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0625D5C4130248B562A9D6130E2
        8B45F5984BF5984BF5984B000000808080C0C0C0000000BA7339F5984BF5984B
        F5984BF5984BF5984BA46632000000C0C0C0808080000000A46632F5984BF598
        4BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BE28B459D61308B
        562A413024625D5CC0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C05A54524432
        268B562AAA6934EA9148F5984BF5984BF5984BA46632000000000000BA7339F5
        984BF5984BF5984BF5984BF5984BF5984BF5984BA46632000000C0C0C0808080
        000000A46632F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF598
        4BEA9148AA69348B562A4432265A5452C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C0625D5C4130248B562ABC7439EF9449F5984BF5984BF5984BF5984BA466
        32000000F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B00
        0000808080C0C0C0000000A46632F5984BF5984BF5984BF5984BF5984BF5984B
        F5984BF5984BF5984BEF9449BC74398B562A413024625D5CC0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C05B5A5A4130248D572BCE803FF2954AF5984BF5984B
        F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF598
        4BF5984BF5984BA46632000000C0C0C0808080000000A46632F5984BF5984BF5
        984BF5984BF5984BF5984BF5984BF5984BF2954ACE803F8D572B4130245B5A5A
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0625D5C4231258E582BDC8843F3
        964AF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B
        F5984BF5984BF5984BF5984BF5984BF5984BA46632000000C0C0C08080800000
        00A46632F5984BF5984BF5984BF5984BF5984BF5984BF5984BF3964ADC88438E
        582B423125625D5CC0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0625D5C4534
        268E582BDC8843F4974BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5
        984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B000000
        808080C0C0C0000000A46632F5984BF5984BF5984BF5984BF5984BF5984BF598
        4BF4974BDC88438E582B453426625D5CC0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C05A54524534268E582BD28240F4974BF5984BF5984BF5984BF5984BF598
        4BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5
        984BF5984BA46632000000C0C0C0808080000000A46632F5984BF5984BF5984B
        F5984BF5984BF5984BF4974BD282408E582B4534265A5452C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C07170704534268B562ABE753AF3964AF5984BF5984B
        F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF598
        4BF5984BF5984BF5984BF5984BF5984BA46632000000C0C0C0808080000000A4
        6632F5984BF5984BF5984BF5984BF5984BF3964ABE753A8B562A453426717070
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0AFAEAE443226865329A06331E8
        9047F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B
        F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BBA73390000
        00C0C0C0000000A46632F5984BF5984BF5984BF5984BF2954AE89047A0633186
        5329443226AFAEAEC0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C04534
        267C522F865329CA7D3EF4974BF5984BF5984BF5984BF5984BF5984BF5984BF5
        984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B
        F5984BA46632000000808080C0C0C0000000A46632F5984BF5984BF5984BF497
        4BCA7D3E8653297C522F453426C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C0C0C0C03C37354130248250289D6130E28C45F5984BF5984BF5984BF598
        4BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5
        984BF5984BF5984BF5984BF5984BA46632000000C0C0C0000000A46632F5984B
        F5984BF5984BE28C459D61308250284130243C3735C0C0C0C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C0C0C0C094949341302474543B855229C4793CF5984B
        F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF598
        4BF5984BF5984BF5984BF5984BF5984BF5984BF5984BA46632000000808080C0
        C0C0000000A46632F5984BF09449C4793C85522974543B413024949493C0C0C0
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C04A47463D2E237C
        522FA46532E18B45F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B
        F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF598
        4BA46632000000000000000000A46632F5984BE18B45A465327C522F3D2E234A
        4746C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C09494932C25235C4432865329CE803FEF9449F5984BF5984BF5984BF5984BF5
        984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B
        F5984BF5984BF5984BF5984BA46632A46632A46632A46632EF9449CE803F8653
        295C44322C2523949493C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0CECECE3333335C4432825028B06D36E38D46F4974BF698
        4BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5
        984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF4974B
        E38D46B06D368250285C4432333333CECECEC0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0949493423125754F2F865329
        CA7D3EEB9248F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF598
        4BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF2
        954AF5984BEB9248CA7D3E865329754F2F423125949493C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C04F
        4F4F48372A7C4E29995F2FD08140EB9248F5984BF5984BF5984BF5984BF5984B
        F5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF598
        4BF5984BF5984BF4974BEB9248D08140995F2F7C4E2948372A4F4F4FC0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0CECECE302E2D48372A7C4E29995F2FCA7D3EF5984BF5984BF5
        984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984BF5984B
        F5984BF3964AF6984BF6984BF2954AE58E46CA7D3E995F2F7C4E2948372A302E
        2DCECECEC0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0AFAEAE25232248372A804F278754
        29B97339DD8944EF9449F6984BF5984BF5984BF5984BF5984BF5984BF5984BF5
        984BF5984BF5984BF5984BF6984BF6984BEF9449DD8944B97339875429804F27
        48372A252322AFAEAEC0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0949493
        3329225240317C4E29825028AA6934D68542EE9349F5984BF5984BF5984BF598
        4BF5984BF5984BF5984BF5984BF5984BF5984BF5984BEE9349D68542AA693482
        50287C4E29524031332922949493C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C09494931616153D2E237C4E29804F27A06331D28240E89047
        F2954AF4974BF5984BF5984BF5984BF5984BF5984BF5984BF5984BE89047D282
        40A06331804F277C4E293D2E23161615949493C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0949493201E1D332922754F2F80
        4F27995F2FC2783CD48341D88642DD8944F2954AEB9248E38D46DD8944D88642
        D48341C2783C995F2F804F27754F2F332922201E1D949493C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C09494
        932523222C221C4C3B2D7C522F8653298E582B935B2D965D2EB06D36A767339B
        602F965D2E935B2D8E582B8653297C522F4C3B2D2C221C252322949493C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0CECECE434141060503523D2E74543B83542E8854298955
        2A8A552A8A552A89552A89552A88542983542E74543B523D2E060503434141CE
        CECEC0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C09494934F4F4F090605
        09060509060515100D46382B42362B261E1915100D0906050906050906054F4F
        4F949493C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C000C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0CECECE434141000000000000000000000000000000000000000000
        434141CECECEC0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0000B0909C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0
        C000}
    end
  end
  object OpenPictureDialog: TOpenPictureDialog
    Left = 270
    Top = 100
  end
  object FontDialog: TFontDialog
    Font.Charset = ANSI_CHARSET
    Font.Color = clWindowText
    Font.Height = -7
    Font.Name = 'Courier New'
    Font.Style = []
    Options = [fdEffects, fdApplyButton]
    OnApply = FontDialogApply
    Left = 305
    Top = 100
  end
end
